
    var httpRequestTimeout = 8000;
    var tracks = new Array();
    var tabId;
    var tabURL;
    var ads_enabled = "ads-enabled";
    var analytics_enabled = "analytics-enabled";
    var social_enabled = "social-enabled";
    var flash_enabled = "flash-enabled";
    var track_enabled = "track-enabled";
    var block_mode = "block-mode-enabled";
    var settings;
    var debug;
    var adsTypes = new Array();
    var patterns = new Array();
    var names = new Array();
    var types = new Array();
    var flashExceptions = new Array();
    var adsExceptions = new Array();
    var blockParts = new Array();
    var specSocialBlocks = new Array();
    var locale = Components.classes["@mozilla.org/intl/stringbundle;1"]
                                        .getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://linkcheker/locale/linkchecker.properties");
    var init = false;
    var notBlockThisTabs = 0;
    var allowUpload = true;
    var manualHidingMode = false;

    setInterval(function() {if (prefs.getBoolPref("updateDataBase")) {
        prefs.setBoolPref("updateDataBase", false);
        initializeData();
        prefs.setCharPref("updateDate", getDateTimeString(new Date()));
    }}, 500);

    //getting localStorage object value
    getLocalStorageValue = function(name)
    {
        return localStorage[name];
    }
    //getting localStorage object value
    setLocalStorageValue = function(name, value)
    {
       localStorage[name] = value;
    }

    //settings item - structure of database item
    settingsItem = function(id, name, type, pattern, block)
    {
        this.id = id;
        this.name = name;
        this.type= type;
        this.block= block;
        this.pattern = pattern;
    }

    //exception item - structure of database item
    exceptionItem = function(id, baseURL, allow)
    {
        this.id = id;
        this.baseURL = baseURL;
        this.allow= allow;
    }

    //ads block - structure of database item
    adsBlock = function(baseURL, id, className)
    {
        this.id = id;
        this.baseURL = baseURL;
        this.className= className;
    }

    //blocked item - structure of database item
    blockedItem = function(id, baseURL, actualURL, tagName, className, prtNodeClass, prtGrandNodeClass, DOMstring, block)
    {
        this.id = id;
        this.baseURL = baseURL;
        this.actualURL = actualURL;
        this.tagName= tagName;
        this.className= className;
        this.prtNodeClass = prtNodeClass;
        this.prtGrandNodeClass = prtGrandNodeClass;
        this.DOMstring = DOMstring;
        this.block = block;
    }

    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefService).getBranch("extensions.linkchecker.");

    initializeData();
    function initializeData()
    {
        var versionJSON = getJSON("http://ftp.drweb.com/pub/drweb/linkchecker/Bases/.version.json?" + Math.random());
        if (versionJSON != undefined) {
            var vdata;
            vdata = JSON.parse(versionJSON);
            if (prefs.getCharPref("version") == "" || prefs.getCharPref("version") != vdata.version.message)
            {
                var dataJSON = getJSON("http://ftp.drweb.com/pub/drweb/linkchecker/Bases/.db.json?" + Math.random());
                if (dataJSON != undefined) {
                    var db;
                    db = JSON.parse(dataJSON);
                    prefs.setCharPref("patterns", db.patterns.message);
                    prefs.setCharPref("names", db.names.message);
                    prefs.setCharPref("types", db.types.message);
                    prefs.setCharPref("socialURLs", db.socialURLs.message);
                    prefs.setCharPref("socialBlocksIds", db.socialBlocksIds.message);
                    prefs.setCharPref("socialBlocksClasses", db.socialBlocksClasses.message);
                }
                prefs.setCharPref("version", vdata.version.message);
                prefs.setCharPref("updateDate", getDateTimeString(new Date()));
            }
        }
        if (prefs.getCharPref("patterns") == "" ||
            prefs.getCharPref("names") == "" ||
            prefs.getCharPref("types") == "" ||
            prefs.getCharPref("socialURLs") == "" ||
            prefs.getCharPref("socialBlocksIds") == "" ||
            prefs.getCharPref("socialBlocksClasses") == "")
        {
            patterns = db.data.patterns;
            names = db.data.names;
            types = db.data.types;

            //special blocks in social networks
            socialURLs = db.data.socialURLs;
            socialBlocksIds = db.data.socialBlocksIds;
            socialBlocksClasses = db.data.socialBlocksClasses;
        }
        else
        {
            patterns = prefs.getCharPref("patterns").split('@');
            names = prefs.getCharPref("names").split('@');
            types = prefs.getCharPref("types").split('@');

            //special blocks in social networks
            socialURLs = prefs.getCharPref("socialURLs").split('@');
            socialBlocksIds = prefs.getCharPref("socialBlocksIds").split('@');
            socialBlocksClasses = prefs.getCharPref("socialBlocksClasses").split('@');
        }
        var options = new Array();
        for (var i=0; i < patterns.length; i++){
             options.push(new this.settingsItem(
                i+1,
                getString(names[i]),
                getString(types[i]),
                getString(patterns[i]),
                "true"
             ))
        }

        for (var i=0; i < socialURLs.length; i++){
             specSocialBlocks.push(new this.adsBlock(
                socialURLs[i],
                socialBlocksIds[i],
                socialBlocksClasses[i]
             ))
        }

        settings = options;
    }

    function getDateTimeString(date)
    {
       curDate = date.getDate();
       if (curDate < 10) curDate = "0" + curDate;

       curMonth = date.getMonth() + 1;
       if (curMonth < 10) curMonth = "0" + curMonth;

       curHour = date.getHours();
       if (curHour < 10) curHour = "0" + curHour;

       curMinute = date.getMinutes();
       if (curMinute < 10) curMinute = "0" + curMinute;

       curSeconds = date.getSeconds();
       if (curSeconds < 10) curSeconds = "0" + curSeconds;

       return curDate + "." + curMonth + "." +  date.getFullYear() + " <font style='color: graytext'>" +  curHour + ":" + curMinute + ":" + curSeconds + "</font>";
    }

    function getJSON(url) {
        if (!url) { return null; }

        method = 'GET';
        async = false;
        data = null;

        var req = new XMLHttpRequest();
        req.open(method, url, async);
        if (req.overrideMimeType) {
            req.overrideMimeType("text/plain; charset=utf-8");
        }

        if (async) {
            req.onreadystatechange = function() {
                if ((req.readyState === 4) && (req.status === 200)) {
                    var response = req.responseText;
                    var headers = req.getAllResponseHeaders();
                    if (typeof callback === 'function') {
                        callback(response, headers);
                    } else {
                        return response;
                    }
                }
                return null;
            };

            req.send(data);
        } else {
            req.send(data);
            return req.responseText;
        }
        return null;
    }

    function getString(string){
        var value = "";
        if (string.length == 0) return null;
        var abs = new Array();
        abs = string.split("-");
        for (i = 0; i < abs.length; i++) {
            if (abs[i] != ""){
                var char = String.fromCharCode(parseInt(abs[i]));
                value += char.toString();
            }
        }
        return value;
    }

    function setFirstRunPreferences()
    {
        var drwebButtonId = "drweb-button";
        var toolbarId = "nav-bar";

            var toolbar = document.getElementById(toolbarId);
            // If no afterId is given, then append the item to the toolbar
            var before = null;
            toolbar.insertItem(drwebButtonId, before);
            toolbar.setAttribute("currentset", toolbar.currentSet);
            document.persist(toolbar.id, "currentset");

            if (toolbarId == "addon-bar")
            toolbar.collapsed = false;

        Services.prefs.setBoolPref("extensions.linkchecker.firstrun2", false);
        setTimeout(function() {openWizard();}, 2000);
    }

    function openWizard()
    {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                                     .getService(Components.interfaces.nsIWindowMediator);
        var browserEnumerator = wm.getEnumerator("navigator:browser");
        var wizardURL = "chrome://linkcheker/content/wizard.html";

        var tBrowser = top.document.getElementById("content");
        var tab = tBrowser.addTab(wizardURL);
        tBrowser.selectedTab = tab;
    }

    var httpRequestObserver = {
        observe : function(aSubject, aTopic, aData) {
        var pathArray = gBrowser.currentURI.spec.split( '/' );
        var baseURL = pathArray[2];
        if (aTopic == "http-on-modify-request") {
          var httpChannel = aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
          if (httpChannel.referrer)
          {
              var referrerHost = httpChannel.referrer.host;
              var requestedURL = httpChannel.URI.spec;
              drweb.tracklist.tabStoredURL = referrerHost;

              for(var i=0; i < settings.length; i++)
              {
                  var patt = RegExp(settings[i].pattern);
                  if (patt.test(requestedURL))
                  {
                     if (requestedURL.indexOf("vk.com/widget_comments") != -1)
                     {
                         if (prefs.getBoolPref(social_enabled)){
                            drweb.tracklist.addTrack2(new drweb.tracklist.track(requestedURL, baseURL, settings[i].block, settings[i].type, settings[i].name, settings[i].pattern));
                            httpChannel.cancel(Components.results.NS_BINDING_ABORTED);
                         }
                         return;
                     }
                     if (settings[i].type == "Web Analytics" && prefs.getBoolPref(analytics_enabled))
                     {
                         drweb.tracklist.addTrack2(new drweb.tracklist.track(requestedURL, baseURL, settings[i].block, settings[i].type, settings[i].name, settings[i].pattern));
                         httpChannel.cancel(Components.results.NS_BINDING_ABORTED);
                     }
                     else if (settings[i].type == "Social Buttons" && prefs.getBoolPref(social_enabled)
                         && baseURL.indexOf("vk.com") == -1 && baseURL.indexOf("vkontakte.ru") == -1
                         && baseURL.indexOf("facebook.com") == -1 && baseURL.indexOf("plus.google.com") == -1)
                     {
                         drweb.tracklist.addTrack2(new drweb.tracklist.track(requestedURL, baseURL, settings[i].block, settings[i].type, settings[i].name, settings[i].pattern));
                         httpChannel.cancel(Components.results.NS_BINDING_ABORTED);
                     }
                     else if (settings[i].type == "Tracking" && prefs.getBoolPref(track_enabled))
                     {
                         drweb.tracklist.addTrack2(new drweb.tracklist.track(requestedURL, baseURL, settings[i].block, settings[i].type, settings[i].name, settings[i].pattern));
                         httpChannel.cancel(Components.results.NS_BINDING_ABORTED);
                     }
                     else if (settings[i].type == "Ads")
                     {

                          var siteExc = getException("ads", baseURL);
                          if (siteExc != null)
                          {
                              if (!siteExc.allow)
                              {
                                  drweb.tracklist.addTrack2(new drweb.tracklist.track(requestedURL, baseURL, settings[i].block, settings[i].type, settings[i].name, settings[i].pattern));
                                  httpChannel.cancel(Components.results.NS_BINDING_ABORTED);
                              }
                          }
                          else if (prefs.getBoolPref(ads_enabled)){
                              drweb.tracklist.addTrack2(new drweb.tracklist.track(requestedURL, baseURL, settings[i].block, settings[i].type, settings[i].name, settings[i].pattern));
                              httpChannel.cancel(Components.results.NS_BINDING_ABORTED);
                          }
                     }
                  }
              }
          }
        }
      }
    }

    getException = function(type, host)
    {
         var baseURL = host;
         if (type == "flash")
         {
             var jsString = prefs.getCharPref("flashExceptions");
             if (jsString != null &&
                 jsString != undefined &&
                 jsString != "")
                 {
                 var flashExceptions = JSON.parse(jsString);
                 var index = exceptionExist(flashExceptions, baseURL);
                 if (index != null)
                    return flashExceptions[index];
                }
         }
         else if (type == "ads")
         {
             var jsString = prefs.getCharPref("adsExceptions");
                         if (jsString != null &&
                             jsString != undefined &&
                             jsString != "")
                {
                 var adsExceptions = JSON.parse(jsString);
                 var index = exceptionExist(adsExceptions, baseURL);
                 if (index != null)
                    return adsExceptions[index];
                }
         }
         return null;
    }

    exceptionExist = function(storage, baseURL)
    {
         for (var i=0; i < storage.length; i++)
         {
            if (storage[i].baseURL)
                var storageURL = storage[i].baseURL.replace("www.", "");
            if (baseURL)
                var actualURL = baseURL.replace("www.", "");
            if (storageURL == actualURL && actualURL != "")
                return i;
         }
         return null;
    }

    getCounters = function()
    {
        if (!counters)
        {
            var counters = new Array();
            for(var i=0; i < settings.length; i++)
            {
                if (settings[i].type == "Tracking")
                {
                   counters.push(settings[i].pattern);
                }
            }
        }
        return counters;
    }

    hideCounters = function(patterns, tag, attribute)
    {
          if (patterns.length > 0)
          {
              var elements = gBrowser.contentDocument.getElementsByTagName(tag);
              for (var j=0; j < elements.length; j++){
                   if (elements[j].getAttribute(attribute))
                   {
                      var src = elements[j].getAttribute(attribute);
                      if (src)
                      {
                          for (var i=0; i < patterns.length; i++){
                             var patt = RegExp(patterns[i]);
                             if (patt.test(src)){
                                 elements[j].style.display = "none";
                             }
                          }
                      }
                   }
              }
          }
    }

    contentsInit = function()
    {
        if (gBrowser.currentURI.spec !="about:blank")
        {
            var pathArray = gBrowser.currentURI.spec.split( '/' );
            var baseURL = pathArray[2];
            hideBlockedItems2();
            if (prefs.getBoolPref(social_enabled)){
                var socialPatterns = getPatterns("Social Buttons");
                hideElement2(socialPatterns, "a", "href");
                hideElement2(socialPatterns, "iframe", "src");
            }

            if (prefs.getBoolPref(track_enabled)){
                var countersPatts = getCounters();
                hideCounters(countersPatts, "a", "href");
                hideCounters(countersPatts, "img", "src");
            }

            var flashException = getException("flash", baseURL);
            if (flashException)
            {
                if (!flashException.allow)
                {
                   hideFlash();
                }
            }
            else if (prefs.getBoolPref(flash_enabled)){
                hideFlash();
            }
            var adsException = getException("ads", baseURL);
            if (adsException)
            {
                if (!adsException.allow)
                {
                    if (!isItSocialNetwork())
                    {
                        var adsPatterns = getPatterns("Ads");
                        hideElement2(adsPatterns, "a", "href");
                        hideElement2(adsPatterns, "iframe", "src");
                        hideSpecTags("yatag");
                        hideSpecTags("ins");
                    }
                    else
                    {
                        for (var i = 0; i< specSocialBlocks.length; i++)
                        {
                             if (baseURL.indexOf(specSocialBlocks[i].baseURL) != -1)
                             {
                                 hideSpecialBlocks(specSocialBlocks[i]);
                             }
                        }
                    }
                }
            }
            else if (prefs.getBoolPref(ads_enabled)){
                 if (!isItSocialNetwork())
                 {
                    var adsPatterns = getPatterns("Ads");
                    hideElement2(adsPatterns, "a", "href");
                    hideElement2(adsPatterns, "iframe", "src");
                    hideSpecTags("yatag");
                    hideSpecTags("ins");
                 }
                 else
                 {
                     for (var i = 0; i< specSocialBlocks.length; i++)
                     {
                         if (baseURL.indexOf(specSocialBlocks[i].baseURL) != -1)
                         {
                             hideSpecialBlocks(specSocialBlocks[i]);
                         }
                     }
                 }
            }
          init = true;

        }
    }

    //hide flash
    hideFlash = function()
    {
        var elementsObjects = gBrowser.contentDocument.getElementsByTagName("object");
        for (var j=0; j < elementsObjects.length; j++){
            elementsObjects[j].style.display = "none";
        }
        var elementsEmbed = gBrowser.contentDocument.getElementsByTagName("embed");
        for (var j=0; j < elementsEmbed.length; j++){
            elementsEmbed[j].style.display = "none";
        }
    }

     hideSpecTags = function(tag)
     {
          var elements = document.getElementsByTagName(tag);
          for (var j=0; j < elements.length; j++){
              $(elements[j]).remove();
          }
     }

    //hiding element by pattern
    hideElement = function(patterns, tag, attribute)
    {
          if (patterns)
          {
              var elements = gBrowser.contentDocument.getElementsByTagName(tag);
              for (var i=0; i < patterns.length; i++){
                  for (var j=0; j < elements.length; j++){
                      var patt = RegExp(getString(patterns[i]));
                      if (patt.test(elements[j].getAttribute(attribute)))
                          elements[j].style.display = "none";
                  }
              }
          }
    }

    //hiding element by pattern
    hideElement2 = function(patterns, tag, attribute)
    {
          if (patterns)
          {
              var elements = gBrowser.contentDocument.getElementsByTagName(tag);
              for (var j=0; j < elements.length; j++){
                   if (elements[j].getAttribute(attribute))
                   {
                       for (var i=0; i < patterns.length; i++){
                          var patt = RegExp(patterns[i].patt);
                          if (patt.test(elements[j].getAttribute(attribute))){
                              elements[j].style.display = "none";
                          }
                       }
                   }
              }
          }
    }

    //hide special blocks like Ads in VK, Facebook
    hideSpecialBlocks = function(specSocialBlock)
    {
        var ids = specSocialBlock.id.split("%");
        for (var j = 0; j< ids.length; j++)
        {
            if (ids[j] != "")
            {
                var element = gBrowser.contentDocument.getElementById(ids[j]);
                if (element)
                {
                    element.style.display = "none";
                }
            }
        }
        ids = null;

        var classes = specSocialBlock.className.split("%");
        for (var j = 0; j< classes.length; j++)
        {
            if (classes[j] != "")
            {
                  var elements = gBrowser.contentDocument.getElementsByClassName(classes[j]);
                  if (elements)
                  {
                      for (var i = 0; i< elements.length; i++)
                      {
                        elements[i].style.display = "none";
                      }
                  }
            }
        }
        classes = null;
    }

    //social
    isItSocialNetwork = function()
    {
        var actualURL = gBrowser.currentURI.spec;
        var socialURLs = new Array("vkontakte.ru", "vk.com", "facebook.com", "fb.com", "plus.google.com");
        for (var i = 0; i< socialURLs.length; i++)
        {
            if (actualURL.indexOf(socialURLs[i]) != -1)
            {
                return true;
            }
        }

        return false;
    }

    hideBlockedItems2 = function()
    {
        if (prefs.getCharPref("blockedParts") == "")
            return;

        var blockedParts = JSON.parse(prefs.getCharPref("blockedParts"));
        if (blockedParts)
        {
            var pathArray = gBrowser.currentURI.spec.split( '/' );
            var baseURL = pathArray[2];
            var divs = gBrowser.contentDocument.getElementsByTagName("DIV");
            var spans = gBrowser.contentDocument.getElementsByTagName("SPAN");
            var imgs = gBrowser.contentDocument.getElementsByTagName("IMG");
            var tables = gBrowser.contentDocument.getElementsByTagName("TABLE");
            var objs = gBrowser.contentDocument.getElementsByTagName("OBJECT");
            var embeds = gBrowser.contentDocument.getElementsByTagName("EMBED");
            for (var i=0; i < blockedParts.length; i++){
                var item = blockedParts[i];
                if (item.baseURL == baseURL && item.block)// && item.actualURL == actualURL)
                {
                    for(var j = 0; j < divs.length; j++)
                    {
                        if ((divs[j].className == item.className || (divs[j].id == item.id && item.id != null && item.id != ""))  && item.tagName == "DIV")
                        {
                            if (item.DOMstring == getDOMstring(divs[j]))
                            {
                                divs[j].style.display = "none";
                            }
                        }
                    }

                    for(var j = 0; j < spans.length; j++)
                    {
                        if ((spans[j].className == item.className || (spans[j].id == item.id && item.id != null && item.id != ""))  && item.tagName == "SPAN")
                        {
                            if (item.DOMstring == getDOMstring(spans[j]))
                            {
                                spans[j].style.display = "none";
                            }
                        }
                    }

                    for(var j = 0; j < imgs.length; j++)
                    {
                        if ((imgs[j].className == item.className || (imgs[j].id == item.id && item.id != null && item.id != ""))  && item.tagName == "IMG")
                        {
                            if (item.DOMstring == getDOMstring(imgs[j]))
                            {
                                imgs[j].style.display = "none";
                            }
                        }
                    }

                    for(var j = 0; j < tables.length; j++)
                    {
                        if (tables[j].className == item.className && item.tagName == "TABLE")
                        {
                            if (item.DOMstring == getDOMstring(tables[j]))
                            {
                                tables[j].style.display = "none";
                            }
                        }
                    }

                    for(var j = 0; j < objs.length; j++)
                    {
                        if (objs[j].className == item.className && item.tagName == "OBJECT")
                        {
                            if (item.DOMstring == getDOMstring(objs[j]))
                            {
                                objs[j].style.display = "none";
                            }
                        }
                    }

                    for(var j = 0; j < embeds.length; j++)
                    {
                        if (embeds[j].className == item.className && item.tagName == "EMBED")
                        {
                            if (item.DOMstring == getDOMstring(embeds[j]))
                            {
                                embeds[j].style.display = "none";
                            }
                        }
                    }
                }
            }
            divs = null;
            tables = null;
        }
    }

    //get unique DOM string which is identifier for block
    getDOMstring = function(target)
    {
        var DOMstring = "";
       var parentTaregtNode = target.parentNode;
       var chlsNumber = 0;
       for (var i=0; i<parentTaregtNode.children.length; i++)
       {
           if (parentTaregtNode.children[i] == target)
           {
                chlsNumber = i;
                break;
           }
       }
       var childrenCount = 0;
       for (var i=0; i<target.children.length; i++)
       {
           var child = target.children[i];
           if (child.getAttributes && !child.getAttributes("flashLock"))
           {
               childrenCount++;
           }
       }

       var actualChildElemetsCount = 0;
       for (var i=0; i<parentTaregtNode.children.length; i++)
       {
            if (parentTaregtNode.children[i].id != "infoBox")
               actualChildElemetsCount++;
       }
       //target.childElementCount
       DOMstring += "[" + actualChildElemetsCount + "]" + "[" + "]" + "[" + "]" + "[" + chlsNumber + "]";

       var childNumber = 0;
       var toIdent = target;
       while (parentTaregtNode.tagName != "BODY")
       {
           for (var i=0; i<parentTaregtNode.children.length; i++)
           {
               if (parentTaregtNode.children[i] == toIdent)
               {
                    childNumber = childNumber + i;
                    break;
               }
           }
           DOMstring += parentTaregtNode.tagName + "&" + parentTaregtNode.className + "%" + childNumber + "%";
           toIdent = parentTaregtNode;
           parentTaregtNode = parentTaregtNode.parentNode;
       }
       return DOMstring;
    }

    //get patterns by type
    getPatterns = function(type)
    {
         return getTracksInfo2();
    }

    //getting tracks info
    getTracksInfo2 = function(){
        var tracks = drweb.tracklist.getAdsAndSocialTracks(tabId, tabURL);
        return tracks;
    }

    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                    .getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(httpRequestObserver, "http-on-modify-request", false);
    //window.addEventListener("DOMContentLoaded", contentsInit, false);

    var myListener = {
        QueryInterface: XPCOMUtils.generateQI(["nsIWebProgressListener",
                                               "nsISupportsWeakReference"]),

        onStateChange: function(aWebProgress, aRequest, aFlag, aStatus) {
            if (aFlag & Ci.nsIWebProgressListener.STATE_START) {
            }
            if (aFlag & Ci.nsIWebProgressListener.STATE_STOP) {
                contentsInit();
            }
        },

        onLocationChange: function(aProgress, aRequest, aURI) {},
        // For definitions of the remaining functions see related documentation
        onProgressChange: function(aWebProgress, aRequest, curSelf, maxSelf, curTot, maxTot) {},
        onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
        onSecurityChange: function(aWebProgress, aRequest, aState) {}
    }

    window.addEventListener("load", function load(event){
           if (prefs.getBoolPref("firstrun2") == true)
               setFirstRunPreferences();
           gBrowser.addEventListener("DOMContentLoaded", function() { contentsInit();}, false);
    },false);

    gBrowser.addProgressListener(myListener);