if(typeof linkchecker == "undefined")
	var linkchecker = {};
if(typeof linkchecker.drweb == "undefined")
	linkchecker.drweb = {};
if(typeof linkchecker.drweb.com == "undefined")
	linkchecker.drweb.com = {};


linkchecker.drweb.com = new function()
{
	var self = this;
	this.browserType = (typeof Browser != "undefined")? "mobile" : "desktop";
	this.Locale = Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService).createBundle("chrome://linkcheker/locale/linkchecker.properties");
	this.HttpRequestTimeout = 11000;

	this.Startup = function()
	{
		self.PrefManager = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.linkchecker.");
		self.PrefManager.QueryInterface(Ci.nsIPrefBranch2);
		self.PrefManager.addObserver("", self.ObserveOptions, false);

		messageManager.addMessageListener('Linkchecker:BrowserOpenTab', 		self.BrowserOpenTab);
		messageManager.addMessageListener('Linkchecker:BrowserOpenScanLinkTab', self.BrowserOpenScanLinkTab);

		messageManager.addMessageListener('Linkchecker:XMLHttpRequestCheckLink', function(message)
		{
			if(message.json.url)
			{
				var requestUrl = 'http://online.drweb.com/result/?snp=' + message.json.siteName + '&r=xml&url=' + encodeURIComponent(message.json.url);
				var httpRequest = new window.XMLHttpRequest();
				httpRequest.open("GET", requestUrl, true);

				var abortTimeoutId = window.setTimeout(function() {
					httpRequest.abort();
				}, self.HttpRequestTimeout);

				httpRequest.onreadystatechange = function ()
				{
					if (httpRequest.readyState == 4)
					{
						switch (httpRequest.status)
						{
							case 200:
								window.clearTimeout(abortTimeoutId);
								var response = httpRequest.responseText;
							break;

							default:
								var response = '<?xml version="1.0" encoding="UTF-8"?>\
									<dwonline><status>serverUnavailable</status><dwreport></dwreport></dwonline>';
							break;
						}
						message.target.messageManager.sendAsyncMessage("Linkchecker:XMLHttpRequestCheckLink", { 'response' : response, 'url' : message.json.url, 'timelabel' : message.json.timelabel });
					}
				}
				httpRequest.send();
			}
		});

		messageManager.loadFrameScript("chrome://linkcheker/content/commonContent.js", true);

		switch(self.browserType)
		{
			case 'mobile':
				messageManager.loadFrameScript("chrome://linkcheker/content/fennecContent.js", true);
			break;
			case 'desktop':
				messageManager.loadFrameScript("chrome://linkcheker/content/firefoxContent.js", true);
			break;
		}


	}

	this.BrowserOpenTab = function(message)
	{
		if(message.json.url)
		{
			switch(self.browserType)
			{
				case 'mobile':
					Browser.addTab(message.json.url, true);
				break;
				case 'desktop':
					var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
					var mainWindow = wm.getMostRecentWindow("navigator:browser");
					var newTab = mainWindow.gBrowser.addTab(message.json.url);
					mainWindow.gBrowser.selectedTab = newTab;

				break;
			}
		}
	}

	this.BrowserOpenScanLinkTab = function(message)
	{
		if(message.json.url)
		{
			switch(self.browserType)
			{
				case 'mobile':
					var tab = Browser.addTab(message.json.url, true);

					/*tab.browser.addEventListener("load", function(eventObj) {
						eventObj.preventDefault();
						eventObj.stopPropagation();
					}, true);

					tab.browser.addEventListener("DOMContentLoaded", function(eventObj) {
						if(eventObj.target.doctype)
						{
							var doc = eventObj.target;
							var frameCheck = doc.getElementById('framecheck');
							frameCheck.addEventListener("load",
								function(eventObj)
								{
									tab.browser.contentDocument.title = self.Locale.GetStringFromName('scanResult');
									eventObj.target.contentWindow.top.document.getElementById('horizon').style.display = 'none';
									eventObj.target.contentWindow.top.document.getElementById('loadingImage').style.display = 'none';
									eventObj.target.style.display = '';
									eventObj.target.contentDocument.getElementsByTagName('img')[8].addEventListener("click", function(eventObj) {
										tab.browser.contentWindow.close();
										eventObj.preventDefault();
										eventObj.stopPropagation();
									}, true);
								},
							true);
							frameCheck.src = message.json.url;
							tab.browser.contentDocument.title = self.Locale.GetStringFromName('scanning')+'...';
						}
					}, true);*/
				break;
				case 'desktop':
/*
					// not a truth method, use openDialog instead
					var win;
					eval("win = window.open('', 'DrWeb LinkChecker', 'centerscreen,location=yes,width=640,height=400,scrollbars=no,resizable=no'); win.allowLoad = true;");
*/

					// no toolbar supported in dialog window
					var win = openDialog("about:blank", "", "dialog,centerscreen,status=yes,location=1,width=640,height=400,scrollbars=no,resizable=no");

					var loop = setInterval(function() {
						if (win.document.location.href !== "about:blank" && win.document.readyState === "complete") {

							// when checker page loading complete

							var elements = win.document.getElementsByTagName('A'),
								len, i;

							for (i = 0, len = elements.length; i < len; i++) {

								// for all "A" tags user target attribute if doesnt exist

								if (!elements[i].getAttribute('target')) {
									elements[i].setAttribute('target', "blank");
								}
							}

							// Don`t forget close loop
							clearInterval(loop);
						}
					}, 300);

					win.document.title = self.Locale.GetStringFromName('scanning') + '...';

					win.document.location.href = message.json.url;
				break;
			}

		}
	}

	this.ObserveOptions = function(subject, topic, data)
	{
		if (topic == "nsPref:changed")
			messageManager.sendAsyncMessage("Linkchecker:OptionsChanged", { 'label' : data, 'value' : self.PrefManager.getBoolPref(data) });
	}

	this.Shutdown = function()
	{
		self.PrefManager.removeObserver("", self.ObserveOptions);
	}

	this.ScanLink = function()
	{
		switch(self.browserType)
		{
			case 'mobile':
				var url = ContextHelper.popupState.linkURL;
				Browser.selectedBrowser.messageManager.sendAsyncMessage("Linkchecker:ScanLink", { 'url' : url });
			break;
			case 'desktop':
				var isLink = false;
				var selected;
				if (gBrowser.selectedBrowser.contentDocument.activeElement.nodeName.toLowerCase() == "textarea" ||
				(gBrowser.selectedBrowser.contentDocument.activeElement.nodeName.toLowerCase() == "input" &&
				gBrowser.selectedBrowser.contentDocument.activeElement.getAttribute("type").toLowerCase() == "text"))
				{
					var ta = gBrowser.selectedBrowser.contentDocument.activeElement;
					selected = ta.value.substring(ta.selectionStart, ta.selectionEnd);
				} else {
					selected = gBrowser.selectedBrowser.contentWindow.getSelection().toString();
				}

				if(!selected)
				{
					try
					{
						var url = gContextMenu.getLinkURL();
						isLink = true;
					} catch(e) {};
					if(url)
						selected = url;
				}
				if(selected.length > 0)
					gBrowser.selectedBrowser.messageManager.sendAsyncMessage("Linkchecker:ScanLink", { 'url' : selected, 'isLink' : isLink });
				else
					gBrowser.selectedBrowser.contentWindow.alert(self.Locale.GetStringFromName('noLinksInSelection'));
			break;
		}
	}
}

window.addEventListener("load", linkchecker.drweb.com.Startup, false);
window.addEventListener("unload", linkchecker.drweb.com.Shutdown, false);
