﻿if(typeof linkchecker == "undefined")
	var linkchecker = {};
if(typeof linkchecker.drweb == "undefined")
	linkchecker.drweb = {};
if(typeof linkchecker.drweb.com == "undefined")
	linkchecker.drweb.com = {};

linkchecker.drweb.com  = new function()
{
	var self						= 	this;
	this.BoxButtonSubmitId			=	'drwebConfirmationSubmit';
	this.BoxButtonCloseId			= 	'drwebConfirmationClose';
	this.BoxLeftColumnId			= 	'drwebConfirmationLeftColumn';
	this.BoxRightColumnId			=	'drwebConfirmationRightColumn';
	this.BoxId						= 	'drwebConfirmation';
	this.BoxFormId					= 	'drwebConfirmationForm';
	this.LinkAttribute				=	'drweb_check_status';
	this.InfectionNameAttribute 	=	'drweb_check_infection_name';
	this.BoxDrWebDescriptionLink	= 	'drweb_description_link';
	this.BoxDrWebDescription		= 	'drweb_description';
	this.LinkInTextRegexp			=	/(https?:\/\/|ftp:\/\/)?(?:_*?)((?:[a-z0-9-.]+|[а-я0-9-.]+)\.(?:museum|aero|biz|coop|info|name|com|edu|int|net|org|ru|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mil|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw|рф|xn--[^\/]+)(?:\/[^\s]+|\/?))/i;
	this.LinksStatus				=	{};
	this.LinkHrefRegexp				=	/^(https?:\/\/|ftp:\/\/)?(.+\.[^\.\/]+(?:\/.+$|\/$|$))/i;
	this.PrefManager				=	Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.linkchecker.");
	this.OptionsNames				=	this.PrefManager.getChildList("", {});
	this.Locale						=	Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService).createBundle("chrome://linkcheker/locale/linkchecker.properties");

	this.GetElementURL				=	function(el, eventObj)
	{
		var hostname = content.document.location.hostname;
		while(el.parentNode && el.parentNode.nodeName.toUpperCase() != 'BODY')
		{
			if(el.nodeName.toUpperCase() == 'A') {
				if(el.getAttribute('class') == 'video' && self.Sites[hostname].name == 'vkontakte')
					break;
				if(eventObj.type == 'click')
					return this.getURL(el.href);
			}
			el = el.parentNode;
		}
		return false;
	}

	this.GetURL						=	function(link)
	{
		if(link)
		{
			link = link.replace(/\s+/, '');
			var result;
			result = this.linkRegexp.exec(link);
			if(result)
			{
				var url = self.DecodeURIComponentFix(result[1]);
				if(this.extLinkRegexp.test(url))
					return url;
			}
			else
			{
				result = this.extLinkRegexp.exec(link);
				if(result)
				{
					return result[1];
				}
			}
		}
		return false;
	}

	this.GoogleGetElementURL			=	function(el, eventObj)
	{
		while(el.parentNode && el.parentNode.nodeName.toUpperCase() != 'BODY')
		{
			switch(el.nodeName.toUpperCase())
			{
				case 'A':
					if(eventObj.type == 'click')
						return this.getURL(el.href);
					break;

				case 'DIV':
					if(el.getAttribute('data-content-url') && el.getAttribute('data-content-type') != 'application/x-shockwave-flash')
						return this.getURL(el.getAttribute('data-content-url'));
					break;
			}
			el = el.parentNode;
		}
		return false;
	}

	this.GoogleGetURL				=	function(link)
	{
		if(link)
		{
			if(this.hostname == 'm.google.com')
			{
				link = self.DecodeURIComponentFix(link);
				link = link.replace(/\\\//ig, "/");
			}
			link = link.replace(/\s+/, '');
			var result = this.linkRegexp.exec(link);
			if(result)
			{
				return result[1];
			}
		}
		return false;
	}


	this.Sites						=	{
		'vkontakte.ru' :
		{
			'name' : 'vkontakte',
			'linkRegexp' : /.*\/away\.php\?to=([^&]+)/i,
			'extLinkRegexp' : /^((?:https?:\/\/|ftp:\/\/)(?!(?:.+\.)?(?:vkontakte.ru|vk.com|vk.me)(?:\/|$))[^\s]+)/i,
			'getElementURL' : self.GetElementURL,
			'getURL'		: self.GetURL
		},
		'facebook.com' :
		{
			'name' : 'facebook',
			'linkRegexp' : /^.*?\/l\.php\?u=([^&]+)/i,
			'extLinkRegexp' : /^((?:https?:\/\/|ftp:\/\/)(?!(?:.+\.)?(?:facebook.com|fb.com)(?:\/|$))[^\s]+)/i,
			'getElementURL' : self.GetElementURL,
			'getURL'		: self.GetURL
		},
		'plus.google.com' :
		{
			'name' : 'google',
			'linkRegexp' : /^((?:https?:\/\/|ftp:\/\/)(?!(?:.+\.)?google\.(?:ru|com)(?:\/|$)).+)/i,
			'getElementURL' : self.GoogleGetElementURL,
			'getURL'		: self.GoogleGetURL,
			'hostname'		: 'plus.google.com'
		},
		'm.google.com' :
		{
			'name' : 'google',
			'linkRegexp' : /^(?:http:\/\/)?javascript:_window\('((?:https?:\/\/|ftp:\/\/)(?!(?:.+\.)?google\.(?:ru|com)(?:\/|$)).+)'\)/i,
			'getElementURL' : self.GoogleGetElementURL,
			'getURL'		: self.GoogleGetURL,
			'hostname'		: 'm.google.com'
		}
	}

	this.Sites['vk.com'] 			= 	self.Sites['vkontakte.ru'];
	this.Sites['m.vk.com'] 			= 	self.Sites['vkontakte.ru'];
	this.Sites['0.vk.com'] 			= 	self.Sites['vkontakte.ru'];
	this.Sites['t.vk.com'] 			= 	self.Sites['vkontakte.ru'];
	this.Sites['m.vkontakte.ru'] 	= 	self.Sites['vkontakte.ru'];
	this.Sites['0.vkontakte.ru'] 	= 	self.Sites['vkontakte.ru'];
	this.Sites['t.vkontakte.ru'] 	= 	self.Sites['vkontakte.ru'];
	this.Sites['fb.com'] 			= 	self.Sites['facebook.com'];
	this.Sites['www.fb.com']		= 	self.Sites['facebook.com'];
	this.Sites['www.facebook.com'] 	= 	self.Sites['facebook.com'];
	this.Sites['m.facebook.com'] 	= 	self.Sites['facebook.com'];
	this.Sites['0.facebook.com'] 	= 	self.Sites['facebook.com'];




	this.GetOptions = function()
	{
		self.Options = {};
		self.Options["vkontakte-check"] = self.PrefManager.getBoolPref("vkontakte-check");
		self.Options["google-check"] = self.PrefManager.getBoolPref("google-check");
		self.Options["facebook-check"] = self.PrefManager.getBoolPref("facebook-check");
	}


	this.HandleDOMInitEvents = function(eventObj, update)
	{
		update = (typeof update == "undefined") ? false : update;
		if(!update)
		{
			var windowObj = eventObj.originalTarget.defaultView;
			if (windowObj.self != windowObj.top)
				return false;
			self.GetOptions();
		}
		var hostname = content.document.location.hostname;
		if(hostname && typeof self.Sites[hostname] != "undefined")
		{
			if(self.Options[self.Sites[hostname].name+'-check'])
			{
				content.document.addEventListener('keydown', self.CancelDialog, false);
				content.document.addEventListener('click', self.HandleClick, true);
				content.document.addEventListener('mouseup', self.HandleClick, true);
			}
			else if(update)
			{
				content.document.removeEventListener('keydown', self.CancelDialog, false);
				content.document.removeEventListener('click', self.HandleClick, true);
				content.document.removeEventListener('mouseup', self.HandleClick, true);
			}
		}
	}

	this.HandleClick = function(eventObj)
	{
		if(eventObj.which != 1 && eventObj.which != 2)
			return false;

	     var event = eventObj || window.event;
         var target = event.target || event.srcElement;

         if (target.id == "drwebConfirmation")
         {
            var box = content.document.getElementById("drwebConfirmation");
            if(box)
            {
                box.parentNode.removeChild(box);
                box.style.display = "none";
                box = null;
                return;
            }
         }

		var hostname = content.document.location.hostname;
        self.GetOptions();
		if(typeof self.Sites[hostname] != "undefined" && self.Options[self.Sites[hostname].name+'-check'])
		{
			var el = eventObj.target;
			var result;
			if(result = self.Sites[hostname].getElementURL(el, eventObj))
			{
				eventObj.preventDefault();
				eventObj.stopPropagation();

				var url = result;
				var boxTimeLabel = 'timelabel_' + (new Date().getTime()).toString();
				self.Dialog({ 'url' : url, 'hostname' : hostname, 'timelabel' : boxTimeLabel });
				if(typeof self.LinksStatus[url] == "undefined")
				{
					el.removeAttribute('onmousedown');
					self.CheckLink({ 'url' : url, 'hostname' : hostname, 'timelabel' : boxTimeLabel });
				}
				else
				{
					self.SetStatusForDialog({ 'status'  : self.LinksStatus[url].status, 'dwreport' : self.LinksStatus[url].dwreport, 'url' : url, 'timelabel' : boxTimeLabel });
				}

			}
		}
	}

	this.shortUrl = function(url) {
		var len = 250;

		return (url.length > len) ? url.substr(0, len) + '...' : url;
	};

	this.Dialog = function(params)
	{
		var box = content.document.getElementById(self.BoxId);
		try
		{
			box.parentNode.removeChild(box);
			box = null;
		} catch(e) {}

		box = content.document.createElement('div');
		box.setAttribute('id', self.BoxId);
		box.className = params.timelabel;
		content.document.body.appendChild(box);

		var localisedSiteName = self.Locale.GetStringFromName(self.Sites[params.hostname].name + 'Site');
		var header = self.Locale.GetStringFromName('header');
		header = header.replace('$1', localisedSiteName);
		header = header.replace('$2', self.shortUrl(params.url));
		var mainText = self.Locale.GetStringFromName('mainText');
		mainText = mainText.replace('$1', localisedSiteName);
		var additionalText = self.Locale.GetStringFromName('additionalText');
		additionalText = additionalText.replace(/\$1/g, localisedSiteName)


		 var boxText = '<div id="drwebConfirmationBox"><div id="drwebConfirmationHeader"><img src="chrome://linkcheker/skin/images/logo.png" alt="' + self.Locale.GetStringFromName('antivirusTitle')+ '" /></div><div id="drwebConfirmationContent"><div id="'+self.BoxLeftColumnId+'" class="drwebWarning">	</div><div id="'+self.BoxRightColumnId+'">'+ header + mainText +	'<p class="last"><a id="'+self.BoxDrWebDescriptionLink+'" href="javascript:void(0)">' + self.Locale.GetStringFromName('whyWarning') + '</a></p><div id="drweb_description" style="display: none;"><a name="drweb_description"></a><div class="last">'	+ additionalText + '</div></div></div></div><div id="drwebConfirmationFooter"><form id="'+self.BoxFormId+'" action="" method="get" accept-charset="utf-8"><button type="submit" id="'+self.BoxButtonSubmitId+'" disabled="disabled">' + self.Locale.GetStringFromName('scanning') + ' <img src="chrome://linkcheker/skin/images/loadingImage.gif" /></button><input id="'+self.BoxButtonCloseId+'" type="button" value="' + self.Locale.GetStringFromName('close') + '" /></form></div></div>';
		 box.appendChild(self.ParseHTML(boxText));
		 content.document.getElementById('drweb_description').style.display = "none";

		content.document.getElementById(self.BoxButtonSubmitId).disabled = true;
		content.document.getElementById(self.BoxDrWebDescriptionLink).addEventListener('click',
			function(eventObj) {
				self.Toggle(self.BoxDrWebDescription);
				eventObj.preventDefault();
				eventObj.stopPropagation();
				return false;
			}
		, true);

		content.document.getElementById(self.BoxButtonCloseId).addEventListener('click', self.HandleBoxClose, true);
		content.document.getElementById(self.BoxButtonSubmitId).addEventListener('click', function(eventObj) { self.HandleBoxFormSubmit(params.url, eventObj); }, true);
	}

	this.HandleBoxFormSubmit = function(url, eventObj)
	{
		var box = content.document.getElementById(self.BoxId);
		if(box)
		{
			box.parentNode.removeChild(box);
			sendAsyncMessage('Linkchecker:BrowserOpenTab', { 'url' : url });
			eventObj.preventDefault();
			eventObj.stopPropagation();
		}
		return false;
	}

	this.HandleBoxClose = function(eventObj)
	{
		var box = content.document.getElementById(self.BoxId);
		if(box)
		{
			box.parentNode.removeChild(box);
			eventObj.preventDefault();
			eventObj.stopPropagation();
		}
		return false;
	}

	this.CheckLink = function(params)
	{
		if (params.url)
			sendAsyncMessage('Linkchecker:XMLHttpRequestCheckLink', { 'url' : params.url, 'siteName' : self.Sites[params.hostname].name, 'timelabel' : params.timelabel });
	}

	this.XMLHttpRequestCheckLinkHandler = function(message)
	{
		if(message.json.response)
		{
			var dp = Cc["@mozilla.org/xmlextras/domparser;1"].createInstance(Ci.nsIDOMParser);
			var xmlDoc = dp.parseFromString(message.json.response, "text/xml");
			var status = xmlDoc.getElementsByTagName("status")[0].textContent;
			var dwreport = xmlDoc.getElementsByTagName('dwreport')[0].textContent.split('with')[1];
			var unreliability = xmlDoc.getElementsByTagName('pcontrol')[0]? true : false;
			status = (status != "infected" && unreliability)? 'unreliability' : status;
			if(status == "clean" || status == "infected" || status == "unreliability")
			{
				self.LinksStatus[message.json.url] =
				{
					'status'  : status,
					'dwreport' : dwreport,
					'url' : message.json.url
				}
			}
			self.SetStatusForDialog({'status'  : status, 'dwreport' : dwreport, 'url' : message.json.url, 'timelabel' : message.json.timelabel });
		}
	}

	this.SetStatusForDialog = function(link)
	{
		if(content.document.getElementById(self.BoxId) && link.timelabel == content.document.getElementById(self.BoxId).className)
		{
			var leftColumn = content.document.getElementById(self.BoxLeftColumnId);
			var button = content.document.getElementById(self.BoxButtonSubmitId);
			var contentElement = content.document.getElementById(self.BoxRightColumnId);

			if (button) {
				self.EmptyElement(button);
				button.appendChild(self.ParseHTML(self.Locale.GetStringFromName('leaveWebsite')));
			}

			switch(link.status)
			{
				case 'serverUnavailable':
				case 'error':
					if (button) {
						button.removeAttribute('disabled');
					}
					self.EmptyElement(contentElement);
					contentElement.appendChild(self.ParseHTML(self.Locale.GetStringFromName('scanTimeout')));

					leftColumn.className = 'drwebErrorLink';
				break;

				case 'clean':
					if (button)
					{
						button.removeAttribute('disabled');
						button.focus();
					}
					leftColumn.className = 'drwebOkLink';
				break;

				case 'unknown':
					leftColumn.className = 'drwebErrorLink';
				break;

				case 'error':
					self.EmptyElement(contentElement);
					contentElement.appendChild(self.ParseHTML(self.Locale.GetStringFromName('scanError')));

					leftColumn.className = 'drwebErrorLink';
				break;

				case 'infected':
					var infectionName = link.dwreport
					var infectionText = self.Locale.GetStringFromName('infectionText');
					infectionText = infectionText.replace('$1', link.url);
					infectionText = infectionText.replace('$2', infectionName);
					self.EmptyElement(contentElement);
					contentElement.appendChild(self.ParseHTML(infectionText));
					leftColumn.className = 'drwebThreatLink';
				break;

				case 'suspicious':
					leftColumn.className = 'drwebErrorLink';
				break;
				case 'unreliability':
					self.EmptyElement(contentElement);
					contentElement.appendChild(self.ParseHTML(self.Locale.GetStringFromName('siteUnreliabilityMessage').replace('$1', link.url)));
					leftColumn.className = 'drwebThreatLink';
				break;
				case 'progress':
				break;
			}
		}
	}

	this.CancelDialog = function(eventObj)
	{
		var box = content.document.getElementById(self.BoxId);
		if (eventObj.keyCode == '27' && typeof box != "undefined" && box)
		{
			box.parentNode.removeChild(box);
			box = null;
		}
	}

	this.Toggle = function(id)
	{
		var el = content.document.getElementById(id);
		el.style.display = (el.style.display == 'block' ? 'none' : 'block');
		return false;
	}

	this.DecodeURIComponentFix = function(str)
	{
		var str;
		try
		{
			str = decodeURIComponent(str);
		}
		catch(e)
		{
			str = self.Cp2Utf(unescape(str));
		}
		return str;
	}

	this.Cp2Utf = function(txt)
	{
		var out = '';
		for(var i = 0; i < txt.length; i++)
		{
			var ch = txt.charCodeAt(i);
			if(ch >= 192 && ch <= 255)
				out += String.fromCharCode(ch+848);
			else if(ch == 168)
				out += String.fromCharCode(ch+937);
			else if(ch == 184)
				out += String.fromCharCode(ch+841);
			else
				out += txt[i];
		}
		return out;
	}

	this.ParseHTML = function(html) {
		doc = content.document;
		return Components.classes["@mozilla.org/feed-unescapehtml;1"]
											 .getService(Components.interfaces.nsIScriptableUnescapeHTML)
											 .parseFragment(html, false, null, doc.documentElement);
	}

	this.EmptyElement = function(el) {
		while (el.firstChild)
		{
			el.removeChild(el.firstChild);
		};
	}

	this.ScanLink = function()
	{
	}

	this.SetTimeoutHanlder = function()
	{
	}

	var Sss = Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService);
	var Ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
	var Uri = Ios.newURI("chrome://linkcheker/content/style.css", null, null);
	Sss.loadAndRegisterSheet(Uri, Sss.USER_SHEET);
}

addEventListener("DOMContentLoaded", linkchecker.drweb.com.HandleDOMInitEvents, false);
addMessageListener("Linkchecker:OptionsChanged", function(message)
{
 	if( typeof linkchecker.drweb.com.Options[message.json.label] != "undefined")
	{
		linkchecker.drweb.com.Options[message.json.label] = message.json.value;

		var hostname = content.document.location.hostname;
		self.Options[self.Sites[hostname].name+'-check']

		if(hostname && typeof self.Sites[hostname] != "undefined" && self.Sites[hostname].name+'-check' == message.json.label)
		{
			linkchecker.drweb.com.HandleDOMInitEvents(false, true);
		}
	}
 }

 );


addMessageListener("Linkchecker:ScanLink", function(e) { linkchecker.drweb.com.ScanLink(e); });
addMessageListener("Linkchecker:XMLHttpRequestCheckLink", linkchecker.drweb.com.XMLHttpRequestCheckLinkHandler);