var drweb =
{
    tracklist:
    {
        tabs: new Array(),
        trackList: new Array(),

        //initialize objects
        initialize: function()
        {
            this.tabs = new Array();
        },

        //clean objects
        dispose: function()
        {
            this.tabs = null;
        },

        //track object
        track: function(requestURL, url, isBlocked, type, name, patt)
        {
            this.requestURL = requestURL;
            this.url = url;
            this.isBlocked = isBlocked;
            this.type = type;
            this.name = name;
            this.patt = patt;
        },

        //tab object
        tab: function(context, tabId, requestURL, url, isBlocked, type, name,patt)
        {
            this.tabId = tabId;
            this.baseURL = context.getBaseURL(url);
            this.tracks = new Array();
            this.tracks.push(new context.track(requestURL, url, isBlocked, type, name,patt));
        },

        //add track to tracklist
        addTrack: function(tabId, track)
        {
            var tabIndex = this.tabExist(tabId);
            if (tabIndex == -1){
                this.tabs.push(new this.tab(this, tabId, track.requestURL, track.url, track.isBlocked, track.type, track.name, track.patt));
            }
            else if (!this.trackExist(tabIndex, track)){
                this.tabs[tabIndex].tracks.push(track);
            }
        },

        addTrack2: function(track)
        {
            if (!this.trackExist2(track)){
                this.trackList.push(track);
            }
        },

        //check if this is a new tab
        tabExist: function(tabId)
        {
             for (var i=0; i < this.tabs.length; i++){
                 if (this.tabs[i].tabId == tabId)
                    return i;
             }
             return -1;
        },

        //check if this is a new tab
        trackExist: function(tabIndex, track)
        {
             for (var i=0; i < this.tabs[tabIndex].tracks.length; i++){
                 //if the same request url or the same name we just update request url
                 if (this.tabs[tabIndex].tracks[i].requestURL == track.requestURL || this.tabs[tabIndex].tracks[i].name == track.name)
                 {
                    //update track url
                    this.tabs[tabIndex].tracks[i].url = track.url;
                    return true;
                 }
             }
             return false;
        },

        trackExist2: function(track)
        {
             for (var i=0; i < this.trackList.length; i++){
                 //if the same request url or the same name we just update request url
                 if (this.trackList[i].requestURL == track.requestURL || this.trackList[i].name == track.name)
                 {
                    //update track url
                    this.trackList[i].url = track.url;
                    return true;
                 }
             }
             return false;
        },

        //remove tab
        removeTab: function(tabId)
        {
             var tabIndex = this.tabExist(tabId);
             if (tabIndex != -1){
                 this.tabs.splice(tabIndex,1);
             }
        },

        //update tab
        updateTab: function(tabId, tabURL)
        {
             var tabIndex = this.tabExist(tabId);
             if (tabIndex != -1){
                 if (this.tabs[tabIndex].baseURL != this.getBaseURL(tabURL))
                 {
                    this.tabs[tabIndex].baseURL = this.getBaseURL(tabURL);
                    this.tabs[tabIndex].tracks.splice(0,this.tabs[tabIndex].tracks.length);
                 }
             }
        },

        //update track in tracklist
        updateTrack: function(tabId, track)
        {
            var tabIndex = this.tabExist(tabId);
            if (tabIndex != -1){
                for (var i=0; i < this.tabs[tabIndex].tracks.length; i++){
                    if (this.tabs[tabIndex].tracks[i].requestURL == track.requestURL)
                    {
                        this.tabs[tabIndex].tracks[i].isBlocked = track.isBlocked;
                    }
                }
            }
        },

        //get tracks in tab
        getTracks: function(tabId, tabURL)
        {
            var tabIndex = this.tabExist(tabId);
            var tabTracks = new Array();
            if (tabIndex != -1){
                for (var i=0; i < this.tabs[tabIndex].tracks.length; i++){
                    if (this.tabs[tabIndex].tracks[i].url == tabURL){
                        tabTracks.push(this.tabs[tabIndex].tracks[i]);
                    }
                }
                return tabTracks;
            }
            return false;
        },

        //get tracks in tab
        getAdsAndSocialTracks: function(tabId, tabURL)
        {
            var tabIndex = this.tabExist(tabId);
            var tabTracks = new Array();
            if (tabIndex != -1){
                for (var i=0; i < this.tabs[tabIndex].tracks.length; i++){
                    if (this.tabs[tabIndex].tracks[i].url == tabURL && (this.tabs[tabIndex].tracks[i].type == "Ads" || this.tabs[tabIndex].tracks[i].type == "Social Buttons")){
                        tabTracks.push(this.tabs[tabIndex].tracks[i]);
                    }
                }
                return tabTracks;
            }
            return false;
        },

         getTracks2: function(tabURL)
        {
            var tabTracks = new Array();
                for (var i=0; i < this.trackList.length; i++){
                    if (this.trackList[i].url == tabURL){
                        tabTracks.push(this.trackList[i]);
                    }
                }
            return tabTracks;
        },

        //get base url
        getBaseURL: function(url)
        {
            return url.split( '/' )[2];
        },
    }
}