(function(){

    var locale = Components.classes["@mozilla.org/intl/stringbundle;1"]
                                    .getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://linkcheker/locale/linkchecker.properties");

    var on = "on";
    var off = "off";
    var currentStep = 1;
    var drweb =
    {
        settings:
        {
            vk: 'vkontakte-check',
            fb: 'facebook-check',
            gl: 'google-check',
            ads: "ads-enabled",
            flash: "flash-enabled",
            social: "social-enabled",
            analytics: "analytics-enabled",
            track: "track-enabled"
        }
    }

    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                                        .getService(Components.interfaces.nsIPrefService).getBranch("extensions.linkchecker.");

    //initialize
	optionsInit = function()
	{

       el('finish').addEventListener('click', function() {exit();}, false);
       el('openSettings').addEventListener('click', function() {openStep(currentStep, "back");}, false);
       el('back').addEventListener('click', function() {openStep(currentStep, "back");}, false);
       el('next').addEventListener('click', function() {openStep(currentStep, "next");}, false);

       el('setUp').addEventListener('click', function() {openStep(currentStep, "next");}, false);
       el('leaveDefault').addEventListener('click', function() {exit();}, false);

       el('social-frame-on').addEventListener('click', function() {setSetting('social-frame', "on");}, false);
       el('social-frame-off').addEventListener('click', function() {setSetting('social-frame', "off");}, false);

       el('ads-frame-on').addEventListener('click', function() {setSetting('ads-frame', "on");}, false);
       el('ads-frame-off').addEventListener('click', function() {setSetting('ads-frame', "off");}, false);

       el('tracker-frame-on').addEventListener('click', function() {setSetting('tracker-frame', "on");}, false);
       el('tracker-frame-off').addEventListener('click', function() {setSetting('tracker-frame', "off");}, false);


       localize();
	}

    exit = function()
    {
         window.close();
    }

    openSettings = function()
    {

    }

    setSetting = function(item, state)
    {
        el(item + "-" + state).setAttribute("selected", true);
        if (state == "off") el(item + "-on").removeAttribute("selected");
        else el(item + "-off").removeAttribute("selected");

        if (item == "social-frame")
        {
              if (state == on)
              {
                  prefs.setBoolPref(drweb.settings.fb, true);
                  prefs.setBoolPref(drweb.settings.vk, true);
                  prefs.setBoolPref(drweb.settings.gl, true);
              }
              else
              {
                  prefs.setBoolPref(drweb.settings.fb, false);
                  prefs.setBoolPref(drweb.settings.vk, false);
                  prefs.setBoolPref(drweb.settings.gl, false);
              }
        }
        else if (item == "ads-frame")
        {
             if (state == on)
                 prefs.setBoolPref(drweb.settings.ads, true);
             else
                 prefs.setBoolPref(drweb.settings.ads, false);
        }
        else if (item == "flash-frame")
        {
             if (state == on)
                 prefs.setBoolPref(drweb.settings.flash, true);
             else
                 prefs.setBoolPref(drweb.settings.flash, false);
        }
        else if (item == "tracker-frame")
        {
             if (state == on)
             {
                 prefs.setBoolPref(drweb.settings.track, true);
                 prefs.setBoolPref(drweb.settings.analytics, true);
                 prefs.setBoolPref(drweb.settings.social, false);
             }
             else
             {
                 prefs.setBoolPref(drweb.settings.track, false);
                 prefs.setBoolPref(drweb.settings.analytics, false);
                 prefs.setBoolPref(drweb.settings.social, false);
             }
        }
    }

    openStep = function(step, path)
    {
        var currentFrame = el('step' + step);
        var previousFrame = el('step' + (step - 1));
        var nextFrame = el('step' + (step + 1));
        var movingButtons = el('movingButtons');

        var inc = 1;
        if (path == "back")
            inc = -1;

        currentStep = step + inc;

        if (path == "next")
        {
            $('#movingButtons').fadeOut('fast');
            $('#step' + (step + 1)).css("margin-left", "500px");
            $('#step' + (step + 1)).css("opacity", "0");
            $('#step' + step).animate({
                opacity: 0,
                marginLeft: "-500"
              }, 500, function() {
                $( ".wiz-step" ).each(function( index ) {
                  $(this).removeAttr("active");
                });
                if (currentStep == 5)
                    $("#stepIndicators").fadeOut("fast");
                $(this).css("display", "none");
                $('#step' + (step + 1)).css("display", "block");
                $('#step' + (step + 1)).animate({
                    opacity: 1,
                    marginLeft: "0"
                  }, 500, function() {
                       if (currentStep > 1 && currentStep < 5){
                           $('#movingButtons').fadeIn('fast');
                           $("#stepIndicators").fadeIn("fast");
                       }
                       if (currentStep != 5)
                        el("indicatorStep" + currentStep).setAttribute("active", true);
                  });
              });

        }
        else if (path == "back")
        {
            $('#movingButtons').fadeOut('fast');
            $('#step' + (step - 1)).css("margin-left", "-500px");
            $('#step' + (step - 1)).css("opacity", "0");
            $('#step' + step).animate({
                opacity: 0,
                marginLeft: "+500"
              }, 500, function() {
                $( ".wiz-step" ).each(function( index ) {
                  $(this).removeAttr("active");
                });
                if (currentStep ==5)
                    $("#stepIndicators").fadeOut("fast");
                $(this).css("display", "none");
                $('#step' + (step - 1)).css("display", "block");
                $('#step' + (step - 1)).animate({
                    opacity: 1,
                    marginLeft: "0"
                  }, 500, function() {
                       if (currentStep > 1 && currentStep < 5){
                          $('#movingButtons').fadeIn('fast');
                          $("#stepIndicators").fadeIn("fast");
                       }
                       if (currentStep != 5)
                        el("indicatorStep" + currentStep).setAttribute("active", true);
                  });
              });

        }
    }

    //localize document
    localize = function()
    {
         //window.document.title = locale.GetStringFromName("optionsPageTitle");

         localizeObj("privacyPolicy", "privacyPolicy");
         localizeObj("otherSoftware", "otherSoftware");
         localizeObj("copyright", "copyright");

         localizeObj("quickSetup", "quickSetup");
         localizeObj("quickSetupDescription", "quickSetupDescription");
         localizeObj("setUp", "setUp");
         localizeObj("leaveDefault", "leaveDefault");

         localizeObj("back", "back");
         localizeObj("next", "next");

         localizeObj("linksSetup", "linksSetup");
         localizeObj("linksSetupDescription", "linksSetupDescription");
         localizeObj("wiz-social-step-on", "wiz_social_step_on");
         localizeObj("wiz-social-step-off", "wiz_social_step_off");

         localizeObj("adsSetup", "adsSetup");
         localizeObj("adsSetupDescription", "adsSetupDescription");
         localizeObj("wiz-ads-step-on", "wiz_ads_step_on");
         localizeObj("wiz-ads-step-off", "wiz_ads_step_off");

         localizeObj("trackerSetup", "trackerSetup");
         localizeObj("trackerSetupDescription", "trackerSetupDescription");
         localizeObj("wiz-tracker-step-on", "wiz_tracker_step_on");
         localizeObj("wiz-tracker-step-off", "wiz_tracker_step_off");

         localizeObj("finishSetup", "finishSetup");
         localizeObj("finishSetupDescription", "finishSetupDescription");
         localizeObj("openSettings", "openSettings");
         localizeObj("finish", "finish");
    }

    //localize object
    localizeObj = function(objId, locId)
    {
         el(objId).innerHTML =  locale.GetStringFromName(locId);
    }

    //get element by ID
	el = function(id)
    {
        return window.document.getElementById(id);
    }

	window.addEventListener('DOMContentLoaded', optionsInit, false);
})();